// Chooser.c

#include <stdio.h>
#include <stdlib.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/neXtaw/Form.h>
#include <X11/neXtaw/List.h>
#include <XKViewport.h>
// #include <XKList.h>
#include <X11/xpm.h>

#include <GNULinux.xpm>

XtAppContext	context;
Widget			toplevel;
Widget			form;
Widget			viewport;
Widget			list;

int main(int argc, char **argv)
{
	Arg				wargs[20];
	int				nwargs;
	XpmAttributes	xpma;
	Pixmap			pixmap;
	Dimension		width, height;

	nwargs = 0;
	XtSetArg(wargs[nwargs], XtNtitle, (XtArgVal) "Chooser"); ++nwargs;
	toplevel = XtOpenApplication(&context,
		"Chooser",
		NULL, 0,
		&argc, argv,
		NULL,
		shellWidgetClass,
		wargs, nwargs);

	// Load pixmap.
	xpma.valuemask = 0;
	switch (XpmCreatePixmapFromData(XtDisplay(toplevel),
			DefaultRootWindow(XtDisplay(toplevel)),
			PanelXpm,
			&pixmap,
			NULL,
			&xpma))
    {
		case XpmColorError:
			fprintf(stderr,
				": xpm image loaded but did not get all colors needed\n");
			break;
		case XpmColorFailed:
			fprintf(stderr,
				": could not load xpm image (not enough colors available)\n");
			exit(0);
			break;
		case XpmNoMemory:
			fprintf(stderr,
				": could not load xpm image (insufficient memory)\n");
			exit(0);
			break;
		case XpmOpenFailed:
		case XpmFileInvalid:
			fprintf(stderr,
				": could not load xpm image (image broken or corrupt)\n");
			exit(0);
			break;
		case XpmSuccess:
		default:
			// Image loaded ok
			break;
    }

	width = xpma.width;
	height = xpma.height;
	XtVaSetValues(toplevel,
		XtNwidth, (XtArgVal) width,
		XtNheight, (XtArgVal) height,
		NULL);

	nwargs = 0;
	XtSetArg(wargs[nwargs], XtNwidth, (XtArgVal) width); ++nwargs;
	XtSetArg(wargs[nwargs], XtNheight, (XtArgVal) height); ++nwargs;
	XtSetArg(wargs[nwargs], XtNdefaultDistance, (XtArgVal) 0); ++nwargs;
	XtSetArg(wargs[nwargs], XtNbackgroundPixmap, (XtArgVal) pixmap); ++nwargs;
	form = XtCreateManagedWidget("Form",
		formWidgetClass,
		toplevel,
		wargs, nwargs);

	width -= 20;
	height -= 130;
	nwargs = 0;
	XtSetArg(wargs[nwargs], XtNfromVert, (XtArgVal) NULL); ++nwargs;
	XtSetArg(wargs[nwargs], XtNfromHoriz, (XtArgVal) NULL); ++nwargs;
	XtSetArg(wargs[nwargs], XtNvertDistance, (XtArgVal) 120); ++nwargs;
	XtSetArg(wargs[nwargs], XtNhorizDistance, (XtArgVal) 10); ++nwargs;
	XtSetArg(wargs[nwargs], XtNwidth, (XtArgVal) width); ++nwargs;
	XtSetArg(wargs[nwargs], XtNheight, (XtArgVal) height); ++nwargs;
	XtSetArg(wargs[nwargs], XtNallowHoriz, (XtArgVal) True); ++nwargs;
	XtSetArg(wargs[nwargs], XtNallowVert, (XtArgVal) True); ++nwargs;
	XtSetArg(wargs[nwargs], XtNuseRight, (XtArgVal) False); ++nwargs;
	XtSetArg(wargs[nwargs], XtNuseBottom, (XtArgVal) True); ++nwargs;
	XtSetArg(wargs[nwargs], XtNforceBars, (XtArgVal) True); ++nwargs;
	XtSetArg(wargs[nwargs], XtNborderWidth, (XtArgVal) 0); ++nwargs;
	XtSetArg(wargs[nwargs], XtNtop, (XtArgVal) XtChainTop); ++nwargs;
	XtSetArg(wargs[nwargs], XtNbottom, (XtArgVal) XtChainTop); ++nwargs;
	XtSetArg(wargs[nwargs], XtNleft, (XtArgVal) XtChainLeft); ++nwargs;
	XtSetArg(wargs[nwargs], XtNright, (XtArgVal) XtChainLeft); ++nwargs;
	viewport = XtCreateManagedWidget("ViewPort",
		xkViewportWidgetClass,
		form,
		wargs, nwargs);

	nwargs = 0;
	XtSetArg(wargs[nwargs], XtNdefaultColumns, (XtArgVal) 1); ++nwargs;
	XtSetArg(wargs[nwargs], XtNverticalList, (XtArgVal) True); ++nwargs;
	XtSetArg(wargs[nwargs], XtNborderWidth, (XtArgVal) 0); ++nwargs;
	XtSetArg(wargs[nwargs], XtNlabel, (XtArgVal) ""); ++nwargs;
	XtSetArg(wargs[nwargs], 
		XtNbackground, WhitePixelOfScreen(XtScreen(toplevel))); ++nwargs;
	list = XtCreateManagedWidget("Hosts",
		listWidgetClass,
		viewport,
		wargs, nwargs);

	XtRealizeWidget(toplevel);
	XtAppMainLoop(context);
	return 0;
}

