/* $XConsortium: LoginP.h,v 1.7 94/04/17 20:03:54 jim Exp $ */
/*

Copyright (c) 1988  X Consortium

Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

The above copyright notice and this permission notice shall be included
in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE X CONSORTIUM BE LIABLE FOR ANY CLAIM, DAMAGES OR
OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.

Except as contained in this notice, the name of the X Consortium shall
not be used in advertising or otherwise to promote the sale, use or
other dealings in this Software without prior written authorization
from the X Consortium.

*/

/*
	xdm		-	display manager daemon
	Author:		Keith Packard, MIT X Consortium
*/

#ifndef _LoginP_h
#define _LoginP_h

#include <Login.h>
#include <X11/CoreP.h>
#include <X11/xpm.h>

#define GET_NAME	0
#define GET_PASSWD	1
#define DONE		2

// New fields for the login widget instance record.
typedef	struct	_LoginPart
{
	Pixel			textpixel;			// Foreground pixel.

	GC				textGC;				// Pointer to GraphicsContext.
	GC				textBgGC;			// Adding this.
	GC				xorGC;				// Pointer to GraphicsContext.
	Pixmap          pixmap;     		// Login Pixmap.
	XpmAttributes   xpma;      			// Xpm logos data.
	XpmColorSymbol  xpmcs[1];

	char			*unsecure_greet;	// Message displayed when insecure.
	XFontStruct		*font;				// Font for text.
	int				state;				// State.
	int				cursor;				// Current cursor position.
	int				failUp;				// Failure message displayed.
	LoginData		data;				// Name/passwd/bogus.
	char			*sessionArg;		// Argument passed to session.
	void			(*notify_done)();	// Proc to call when done.
	int				failTimeout;		// Seconds til drop fail msg.
	XtIntervalId	interval_id;		// Drop fail message note.
	Boolean			secure_session;		// Session is secured.
	Boolean			allow_access;		// Disable access control on login.
} LoginPart;

// Full instance record declaration.
typedef	struct	_LoginRec
{
	CorePart	core;
	LoginPart	login;
} LoginRec;

// New fields for the Login widget class record.
typedef	struct	{ int dummy; }	LoginClassPart;

// Full class record declaration.
typedef	struct	_LoginClassRec
{
	CoreClassPart	core_class;
	LoginClassPart	login_class;
} LoginClassRec;

// Class pointer.
extern	LoginClassRec	loginClassRec;

#endif /* _LoginP_h */
